
package net.sf.banglapad;


import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.*;
import javax.swing.text.AttributeSet;
import javax.swing.text.Element;

import java.awt.*;

import javax.swing.text.*;
import javax.swing.text.html.*;
import java.net.*;

/**
 * BanglaPadWithFormat.java
 * 
 * @author     Zahurul Islam (zahurul@bracuniversity.net)
 * @author     Naushad UzZaman (naushadzaman@gmail.com)
 * @created    August 10, 2005
 * @version    0.1, December 10, 2005
 */
public class BanglaPadWithFormat extends BanglaPadWithPrinting
{
    private JCheckBoxMenuItem smartMark, banglaMode, wordWrap;
    private boolean wordWrapOn, shortHandOn;
    private ChangeCaseDialog changeCaseDlg;
    private Properties shortHandMap = new Properties();
    File shortHandFile = new File(BPadLogger.supportDir, "shorthand.properties");

    protected SimpleFilter m_jpgFilter;
    protected SimpleFilter m_gifFilter;
    protected SimpleFilter m_pngFilter;
    protected SimpleFilter m_bmpFilter;
    
    private ShowKeyboardDialog showKeyBoardDialog;
    
    /**
     *  Creates a new instance of VietPadWithFormat
     */
    public BanglaPadWithFormat() {
        super();
        wordWrapOn = prefs.getBoolean("wordWrap", true);
        shortHandOn = prefs.getBoolean("shortHand", false);

        m_gifFilter = new SimpleFilter("gif", "GIF images");
        m_jpgFilter = new SimpleFilter("jpg", "JPG images");
        m_pngFilter = new SimpleFilter("png", "PNG images");
        m_bmpFilter = new SimpleFilter("bmp", "BMP images");

        /**
         * FIXME: Code remove
         */
        /*m_editor.setLineWrap(wordWrapOn);*/

        try {
            shortHandMap.load(new FileInputStream(shortHandFile));
        } catch (IOException e) {
            // default values
            shortHandMap.setProperty("vn", "Vi\u1EC7t Nam");
            shortHandMap.setProperty("hn", "H\u00E0 N\u1ED9i");
            shortHandMap.setProperty("sg", "S\u00E0i G\u00F2n");
            shortHandMap.setProperty("qh", "qu\u00EA h\u01B0\u01A1ng");
            shortHandMap.setProperty("sv", "sinh vi\u00EAn");
            shortHandMap.setProperty("c\u0111", "c\u1ED9ng \u0111\u1ED3ng");
            shortHandMap.setProperty("nv", "ng\u01B0\u1EDDi Vi\u1EC7t");
        }

        // pass shorthand map to keylistener
        
        BPadLogger.logger.debug("Calling the createFormatMenu() of VietPadWithFormat class");
        menuBar.add(createFormatMenu(), menuBar.getMenuCount() - 1);
        BPadLogger.logger.debug("Calling the createInsertMenu() of VietPadWithFormat class");
        menuBar.add(createInsertMenu(), menuBar.getMenuCount() - 1);
        BPadLogger.logger.debug("Calling the createKeyboardMenu() of VietPadWithFormat class");
        menuBar.add(createKeyboardMenu(), menuBar.getMenuCount() - 1);
        /**
         * FIXME:Added by Zahurul 
         * for create show keyboard dialog 
         */
        BPadLogger.logger.debug("Calling createShowKeyboardDialog() of VietPadWithForMat class");
        createShowKeyboardDialog();
    }
    /**
     * FIXME:Added by Zahurul
     * method for creating show keyboard dialog
     *
     */
    protected void createShowKeyboardDialog() {
        String[] dialog_labels = {"Show Keyboard Arrangment","Key Map","Font","Close",
                                  "Back","Tab","CapsLock","Enter","Shift","No Alt Key","No Key pairs"};
        BPadLogger.logger.debug("instantiate ShowKeyboardDialog objet by giving parent and dialog labels");
        showKeyBoardDialog = new ShowKeyboardDialog(scrollPane, dialog_labels);
        
    } // createShowKeyboardDialog


    
    private JMenu createInsertMenu() {
        JMenu mInsert = new JMenu("Insert");
        mInsert.setMnemonic('I');
        
        /*
         * FIXME: Added for Image Insert
         */
        JMenuItem item = new JMenuItem("Insert Image");  
        item.setMnemonic('i');
        ActionListener lst = new ActionListener() { 
          public void actionPerformed(ActionEvent e) {
            BPadLogger.logger.debug("user select insert iamge submenu of Insert menu");
            m_chooser.addChoosableFileFilter(m_gifFilter);
            m_chooser.addChoosableFileFilter(m_jpgFilter);
            m_chooser.addChoosableFileFilter(m_pngFilter);
            m_chooser.addChoosableFileFilter(m_bmpFilter);
            m_chooser.setFileFilter(m_gifFilter);
            m_chooser.removeChoosableFileFilter(bngFilter);
            m_chooser.removeChoosableFileFilter(utf8Filter);
            m_chooser.removeChoosableFileFilter(utf16Filter);
            m_chooser.removeChoosableFileFilter(txtFilter);
            BPadLogger.logger.debug("calling inserImage() of VietPadWithFormat class");
            insertImage();  
            m_chooser.addChoosableFileFilter(bngFilter);
            m_chooser.addChoosableFileFilter(txtFilter);
            m_chooser.addChoosableFileFilter(utf8Filter);
            m_chooser.addChoosableFileFilter(utf16Filter);
            m_chooser.setFileFilter(bngFilter);
            m_chooser.removeChoosableFileFilter(m_gifFilter);
            m_chooser.removeChoosableFileFilter(m_jpgFilter);
            m_chooser.removeChoosableFileFilter(m_pngFilter);
            m_chooser.removeChoosableFileFilter(m_bmpFilter);
          }
        };
        item.addActionListener(lst);
        mInsert.add(item);
        
        item = new JMenuItem("Insert Table...");
        item.setMnemonic('t');
        lst = new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                BPadLogger.logger.debug("user select Insert Table submenu of Insert menu");
                BPadLogger.logger.debug("Initialize TableDialog class");
                TableDlg dlg = new TableDlg(BanglaPadWithFormat.this, m_doc);
                dlg.setVisible(true);
                if (dlg.succeeded()) {
                    BPadLogger.logger.debug("calling generateHTML() of TableDialog class");
                    String tableHtml = dlg.generateHTML();
                    Element ep = m_doc.getParagraphElement(
                        m_editor.getSelectionStart());
                    try {
                        BPadLogger.logger.debug("table is being inserted in m_doc");
                        m_doc.insertAfterEnd(ep, tableHtml);
                    }
                    catch (Exception ex) {
                        BPadLogger.logger.error("Exception in insert table action: "+ex);
                    }
//                  documentChanged();
                }
            }
        };
        item.addActionListener(lst);
        mInsert.add(item);
        return mInsert;
    }
    
    /**
     *  Creates the Format menu
     *
     *@return    the Menu Object
     */
    private JMenu createFormatMenu() {
        JMenu mFormat = new JMenu(myResources.getString("Format"));
        mFormat.setMnemonic('o');

        // Word Wrap
        wordWrap = new JCheckBoxMenuItem(myResources.getString("Word_Wrap"), wordWrapOn);
        wordWrap.addActionListener(
            new ActionListener()
            {
                public void actionPerformed(ActionEvent ae) {
                    BPadLogger.logger.debug("Word Wrap checkbox have selected");
                   // m_editor.setLineWrap(wordWrap.isSelected());
                }
            });
        mFormat.add(wordWrap);

        // Font
        JMenuItem item = new JMenuItem(myResources.getString("Font") + "...");
        item.setMnemonic('o');
        item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T, MENU_MASK));

        ActionListener lst =
            new ActionListener()
            {
                public void actionPerformed(ActionEvent e) {
                    BPadLogger.logger.debug("user select font dialog sub menu");
                    BPadLogger.logger.debug("Initializing FontDialog class");
                    FontDialog dlg = new FontDialog(BanglaPadWithFormat.this);
                    AttributeSet a = m_doc.getCharacterElement(
                            m_editor.getCaretPosition()).getAttributes();
                    BPadLogger.logger.debug("Calling setAttribute() of FontDialog class");
                    dlg.setAttributes(a);
                    dlg.setVisible(true);
                    if (dlg.succeeded()) {
                        BPadLogger.logger.debug("Calling getAttribute() of FontDialog class to set the attribute of StyleConstants");
                        setAttributeSet(dlg.getAttributes());
                        BPadLogger.logger.debug("Calling showAttribute() from font dialog actionVietpadWithFormat class");
                        showAttributes(m_editor.getCaretPosition());
                        m_editor.validate();
                    }
                }
            };

        item.addActionListener(lst);
        mFormat.add(item);

        mFormat.addSeparator();

        JMenuItem paragraph = new JMenuItem("Paragraph" + "...");//new JMenuItem(myResources.getString("Paragraph") + "...");
        paragraph.setMnemonic('p');
        //item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T, MENU_MASK));

        ActionListener lst2 =
            new ActionListener()
            {
                public void actionPerformed(ActionEvent e) {
                    BPadLogger.logger.debug("user select paragraph dialog sub menu");
                    BPadLogger.logger.debug("Initialize ParagraphDialog class");
                    ParagraphDialog m_paragraphDialog = new ParagraphDialog(BanglaPadWithFormat.this, imagePath);
                        BanglaPadWithFormat.this.repaint();
                        AttributeSet a = m_doc.getParagraphElement(
                          m_editor.getCaretPosition()).getAttributes();
                        BPadLogger.logger.debug("Calling setAttribute() of ParagraphDialog class");
                        m_paragraphDialog.setAttributes(a);
                        BPadLogger.logger.debug("Calling getSize() of ParagraphDialog class");
                        Dimension d1 = m_paragraphDialog.getSize();
                        Dimension d2 = BanglaPadWithFormat.this.getSize();
                        int x = Math.max((d2.width-d1.width)/2, 0);
                        int y = Math.max((d2.height-d1.height)/2, 0);
                        m_paragraphDialog.setBounds(x + BanglaPadWithFormat.this.getX(),
                          y + BanglaPadWithFormat.this.getY(), d1.width, d1.height);

                        m_paragraphDialog.setVisible(true);
                        if (m_paragraphDialog.getOption()==JOptionPane.OK_OPTION) {
                            BPadLogger.logger.debug("Calling getAttribute() of ParagraphDialog class to setAttribute of StyleConstants");
                          setAttributeSet(m_paragraphDialog.getAttributes(), true);
                          BPadLogger.logger.debug("Calling showAttribute() from paragraph dialog action of VietpadWithFormat class");
                          showAttributes(m_editor.getCaretPosition());
                        }
                  
                }
            };

        paragraph.addActionListener(lst2);
        mFormat.add(paragraph);     
        JMenuItem backGround = new JMenuItem("Background" + "...");//new JMenuItem(myResources.getString("Paragraph") + "...");
        backGround.setMnemonic('b');
        ActionListener colorAct = new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    BPadLogger.logger.debug("user select Background submenu of format menu");
                    Color color = new JColorChooser().showDialog(BanglaPadWithFormat.this,"Choose Text Color",Color.black);
                    m_editor.setBackground(color);
    
                }
            };    
        backGround.addActionListener(colorAct);
        mFormat.add(backGround);

        mFormat.addSeparator();
        
        // Change Case
        Action changeCaseAction =
            new AbstractAction(myResources.getString("Change_Case") + "...")
            {
                public void actionPerformed(ActionEvent e) {
                    BPadLogger.logger.debug("user chose change case submenu of format menu");
                    if (changeCaseDlg == null) {
                        BPadLogger.logger.debug("Initializing ChangeCaseDialog class");
                        changeCaseDlg = new ChangeCaseDialog(BanglaPadWithFormat.this, false);
                        // non-modal
                        BPadLogger.logger.debug("Calling setSelectedCase() of ChangeCaseDialog class from VietPadWithFormat");
                        changeCaseDlg.setSelectedCase(prefs.get("selectedCase", "Upper Case"));
                        changeCaseDlg.setLocation(
                                prefs.getInt("changeCaseX", changeCaseDlg.getX()),
                                prefs.getInt("changeCaseY", changeCaseDlg.getY()));
                    }
                    if (m_editor.getSelectedText() == null) {
                        m_editor.selectAll();
                    }
                    changeCaseDlg.setVisible(true);
                }
            };

        item = mFormat.add(changeCaseAction);
        item.setMnemonic('c');

        // Remove line breaks
        Action removeLineBreaksAction =
            new AbstractAction(myResources.getString("Remove_Line_Breaks"))
            {
                public void actionPerformed(ActionEvent e) {
                    if (m_editor.getSelectedText() == null) {
                        m_editor.selectAll();

                        if (m_editor.getSelectedText() == null) {
                            return;
                        }
                    }
                    String result = m_editor.getSelectedText()
                            .replaceAll("(?<=\n|^)[\t ]+|[\t ]+(?=$|\n)", "")
                            .replaceAll("(?<=.)\n(?=.)", " ");

                    undoSupport.beginUpdate();
                    int start = m_editor.getSelectionStart();
                    m_editor.replaceSelection(result);
                    setSelection(start, start + result.length());
                    undoSupport.endUpdate();
                }
            };
        item = mFormat.add(removeLineBreaksAction);
        item.setMnemonic('r');
        item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R, MENU_MASK));

        return mFormat;
    }

    protected String inputURL(String prompt, String initialValue) {
        BPadLogger.logger.debug("Begining of inputURL() of VietPadWithFormat class");
        JPanel p = new JPanel();
        p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
        p.add(new JLabel(prompt));
        p.add(Box.createHorizontalGlue());
        JButton bt = new JButton("Local File");
        bt.setRequestFocusEnabled(false);
        p.add(bt);

        final JOptionPane op = new JOptionPane(p,
            JOptionPane.PLAIN_MESSAGE, JOptionPane.OK_CANCEL_OPTION);
        op.setWantsInput(true);
        if (initialValue != null)
            op.setInitialSelectionValue(initialValue);

        ActionListener lst = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JFileChooser chooser = new JFileChooser();
                if (chooser.showOpenDialog(BanglaPadWithFormat.this) != JFileChooser.APPROVE_OPTION) {
                    BPadLogger.logger.warn("user doesn't select any file");
                    return;                 
                }

                File f = chooser.getSelectedFile();
                try {
                    String str = f.toURL().toString();
                    op.setInitialSelectionValue(str);
                }
                catch (Exception ex) {
                    BPadLogger.logger.error("problem in setInitialSelectionValue() in ChangeCaseDialog class "+ ex);
                }
            }
        };
        bt.addActionListener(lst);

        JDialog dlg = op.createDialog(this, BPadLogger.APP_NAME);
        dlg.setVisible(true);
        dlg.dispose();

        Object value = op.getInputValue();  // Changed - Pavel
        if(value == JOptionPane.UNINITIALIZED_VALUE) {
            BPadLogger.logger.warn("user doesn't select any file");         
            return null;
            
        }
        String str = (String)value;
        if (str != null && str.length() == 0)
            str = null;
        BPadLogger.logger.debug("return input URl from inputURL() of VietPadWithFormat class");
        return str;
    }

    /**
     *  Insert Image
     * 
     * Inserts an image to the StyledDocument
     */
    public void insertImage(){
        BPadLogger.logger.debug("Begining of insertImage() of VietPadWithFormat class");
        String url = inputURL("Please enter image URL:", null);
        
        if (url == null) {
            System.err.println("The url is null");
            BPadLogger.logger.error("The URL is null in insertImage() of VietPadWithFormat class");
            return;
        }
            
        String imageIn = url.substring(url.indexOf('/'));
        File inF = new File(imageIn);


        String name = imageIn.substring(imageIn.lastIndexOf('/')+1);
        try{
        m_doc.setBase(new URL("file:"+currentTmpFolder+File.separator));
        }catch(Exception e){
            BPadLogger.logger.error("problem with URL in insertImage() of VietPadWithFormat class"+e);
        }
        String imageOut = currentTmpFolder + File.separator + "images" + File.separator + name;
        File outF = new File(imageOut);
        String urlOut = "file:" + imageOut;
        url = urlOut;
        try{
            JCopy.copyFile(inF, outF);
        } catch (Exception e) {
            BPadLogger.logger.error("Exception in copying file "+e);
        }
        
        try {
            ImageIcon icon = new ImageIcon(new URL(url));
            int w = icon.getIconWidth();
            int h = icon.getIconHeight();
            if (w<=0 || h<=0) {
                BPadLogger.logger.warn("Error reading image");
                JOptionPane.showMessageDialog(BanglaPadWithFormat.this,
                    "Error reading image URL\n"+
                    url, BPadLogger.APP_NAME,
                    JOptionPane.WARNING_MESSAGE);
                    return;
            }
            
            url = "images" + "/" + name;
            String base3 = currentTmpFolder.substring(currentTmpFolder.lastIndexOf(File.separator)+1);
            MutableAttributeSet attr = new SimpleAttributeSet();
            attr.addAttribute(StyleConstants.NameAttribute, HTML.Tag.IMG);
            attr.addAttribute(HTML.Attribute.SRC, url);
            attr.addAttribute(HTML.Attribute.DUMMY, base3);
            attr.addAttribute(HTML.Attribute.HEIGHT, Integer.toString(h));
            attr.addAttribute(HTML.Attribute.WIDTH, Integer.toString(w));
            int p = m_editor.getCaretPosition();
            m_doc.insertString(p, " ", attr);
        }
        catch (Exception ex) {
            BPadLogger.logger.error("Exception in insertImage() of VietPadWithFormat class");
        }
        m_chooser.setAcceptAllFileFilterUsed(false);
        m_chooser.addChoosableFileFilter(bngFilter);
        m_chooser.addChoosableFileFilter(txtFilter);
        m_chooser.addChoosableFileFilter(utf8Filter);
        m_chooser.addChoosableFileFilter(utf16Filter);
        m_chooser.setFileFilter(bngFilter);
        m_chooser.removeChoosableFileFilter(m_gifFilter);
        m_chooser.removeChoosableFileFilter(m_jpgFilter);
        m_chooser.removeChoosableFileFilter(m_pngFilter);
        m_chooser.removeChoosableFileFilter(m_bmpFilter);   
        BPadLogger.logger.debug("End of insertImage() of VietPadWithFormat class");
    }
    /**
     *  Changes case
     *
     *@param  typeOfCase  The type that the case should be changed to
     */
    protected void changeCase(String typeOfCase) {
        BPadLogger.logger.debug("Begining of changeCase() of VietPadWithFormat class");
        if (m_editor.getSelectedText() == null) {
            m_editor.selectAll();

            if (m_editor.getSelectedText() == null) {
                return;
            }
        }

        String result = m_editor.getSelectedText();

        if (typeOfCase.equals("UPPERCASE")) {
            result = result.toUpperCase();
        } else if (typeOfCase.equals("lowercase")) {
            result = result.toLowerCase();
        } else if (typeOfCase.equals("Title_Case")) {
            StringBuffer strB = new StringBuffer(result.toLowerCase());
            Pattern pattern = Pattern.compile("(?<!\\p{InCombiningDiacriticalMarks}|\\p{L})\\p{L}");
            // word boundary
            Matcher matcher = pattern.matcher(result);
            while (matcher.find()) {
                int index = matcher.start();
                strB.setCharAt(index, Character.toTitleCase(strB.charAt(index)));
            }
            result = strB.toString();
        } else if (typeOfCase.equals("Sentence_case")) {
            StringBuffer strB = new StringBuffer(result.toUpperCase().equals(result) ? result.toLowerCase() : result);
            Matcher matcher = Pattern.compile("\\p{L}(\\p{L}+)").matcher(result);
            while (matcher.find()) {
                if (!(
                        matcher.group(0).toUpperCase().equals(matcher.group(0)) ||
                        matcher.group(1).toLowerCase().equals(matcher.group(1))
                        )) {
                    for (int i = matcher.start(); i < matcher.end(); i++) {
                        strB.setCharAt(i, Character.toLowerCase(strB.charAt(i)));
                    }
                }
            }
            final String QUOTE = "\"'`,<>\u00AB\u00BB\u2018-\u203A";
            matcher = Pattern.compile("(?:[.?!\u203C-\u2049][])}"
                     + QUOTE + "]*|^|\n|:\\s+["
                     + QUOTE + "])[-=_*\u2010-\u2015\\s]*["
                     + QUOTE + "\\[({]*\\p{L}"
                    ).matcher(result);
            // begin of a sentence
            while (matcher.find()) {
                int i = matcher.end() - 1;
                strB.setCharAt(i, Character.toUpperCase(strB.charAt(i)));
            }
            result = strB.toString();
        }

        undoSupport.beginUpdate();
        int start = m_editor.getSelectionStart();
        m_editor.replaceSelection(result);
        setSelection(start, start + result.length());
        undoSupport.endUpdate();
        BPadLogger.logger.debug("End of changeCase() of VietPadWithFormat class");
    }


    /**
     *  Creates the Keyboard menu
     *
     *@return    the Menu Object
     */
    private JMenu createKeyboardMenu() {
        JMenu mKeyboard = new JMenu(myResources.getString("Keyboard"));
        mKeyboard.setMnemonic('k');

        // Viet Mode item
        banglaMode = new JCheckBoxMenuItem(
                MAC_OS_X ? myResources.getString("Bengali_Mode") + "     \u2325Shift" : myResources.getString("Bengali_Mode"), banglaModeOn);
        banglaMode.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_SHIFT, KeyEvent.ALT_MASK, true));
        banglaMode.addItemListener(
            new ItemListener()
            {
             
                /**
                 * FIXME: Code Extract or modification
                 * Here I only change the letter B instead of V
                 */
                public void itemStateChanged(ItemEvent e) {
                    if (banglaMode.isSelected()) {
                        banglaModeOn = true;
                        banglaModeLabel.setText("B");
                        keybordMenu.setEnabled(true);
                        changeContext();
                        //UserKeyMap.loadUserKeyMap(new File("UI_bengali.kmp"));  // initialize tables
                    } else {
                        banglaModeOn = false;
                        banglaModeLabel.setText("E");
                        keybordMenu.setEnabled(false);
                        changeContext();
                    }
                    BanglaKeyListener.setVietModeEnabled(banglaModeOn);
                    
                    //temporary fix for display glitch in Mac OS X pre Java 1.4.1 Update 1
                    m_toolBar.repaint(0, 2, 2, 8, 32);
                }
            });

        mKeyboard.add(banglaMode);
        mKeyboard.addSeparator();

        // SmartMark item
        /**
         * FIXME : Code Extract or Modification
         * this is for smart mark keyboard input method.
         */
        smartMark = new JCheckBoxMenuItem(myResources.getString("SmartMark"), smartMarkOn);
        smartMark.addItemListener(
            new ItemListener()
            {
                public void itemStateChanged(ItemEvent e) {
                    BPadLogger.logger.debug("user select smartMark checkBox");
                    smartMarkOn = smartMark.isSelected();
                    BPadLogger.logger.debug("calling setSmartMark() VietKeyListener");
                    BanglaKeyListener.setSmartMark(smartMarkOn);
                }
            });
        mKeyboard.add(smartMark);
        m_toolBar.add(Box.createHorizontalStrut(15));
        m_toolBar.add(banglaModeLabel);
        banglaModeLabel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                banglaMode.doClick();
                changeContext();
            }
        });
        
        m_toolBar.add(Box.createHorizontalGlue());
        
        /**
         * FIXME: Code Extarct or Modification
         * shorthand should extract or modify for Bengali support
         */

        // Shorthand item
        /*Action shortHandAction =
            new AbstractAction(myResources.getString("Shorthand") + "...")
            {
                public void actionPerformed(ActionEvent e) {
                    BPadLogger.logger.debug("user select short hand submenu of Keyboard menu");
                    if (shortHandDlg == null) {
                        BPadLogger.logger.debug("Initializinf ShortHandDialog class");
                        shortHandDlg = new ShortHandDialog(VietPadWithFormat.this, true);
                        // modal

                        shortHandDlg.setLocation(
                                prefs.getInt("shortHandX", shortHandDlg.getX()),
                                prefs.getInt("shortHandY", shortHandDlg.getY()));
                    }

                    shortHandDlg.setMacroMap(shortHandMap, shortHandOn);
                    shortHandDlg.setVisible(true);
                }
            };

        JMenuItem item = mKeyboard.add(shortHandAction);
        item.setMnemonic('s');*/
        
        /**
         * FIXME: Added by zahurul
         * Action for show keyboard submenu in keyboard menu
         */
        //keybordMenu = new JMenuItem("Show Bangla Keyboard");
        Action showKeyboard =
            new AbstractAction("Show Bangla Keyboard")
            {
                public void actionPerformed(ActionEvent e) {
                    BPadLogger.logger.debug("user select show keyboard submenu of keyboard menu");
                    if (UserKeyMap.key_table == null) {
                        BPadLogger.logger.debug("Loading user keymap from showKeyboard action of VietPadWithFormat");
                        UserKeyMap.loadUserKeyMap(new File("UI_bengali.kmp"));  // initialize tables                        
                    }
                    BPadLogger.logger.debug("calling showIt() of ShowKeyboardDialog class");
                    showKeyBoardDialog.showIt();
                
                }
            };

            keybordMenu = mKeyboard.add(showKeyboard);
            keybordMenu.setMnemonic('K');


        return mKeyboard;
    }


    /**
     *  Gets the shorthand map
     *
     *@param  map            shorthand map
     *@param  shortHandMode  shorthand on
     */
    public void setShortHandMap(Properties map, boolean shortHandMode) {
        shortHandMap = map;
        shortHandOn = shortHandMode;
        if (shortHandOn) {
            BanglaKeyListener.setMacroMap(shortHandMap);
        } else {
            BanglaKeyListener.setMacroMap(null);
        }
    }


    /**
     *  Updates UI component if changes in LAF
     *
     *@param  laf  The look and feel class name
     */
    protected void updateLaF(String laf) {
        super.updateLaF(laf);

        if (changeCaseDlg != null) {
            SwingUtilities.updateComponentTreeUI(changeCaseDlg);
            changeCaseDlg.pack();
        }
    }


    /**
     *  Quits the application
     */
    protected void quit() {
        prefs.putBoolean("wordWrap", wordWrap.isSelected());

        if (changeCaseDlg != null) {
            prefs.put("selectedCase", changeCaseDlg.getSelectedCase());
            prefs.putInt("changeCaseX", changeCaseDlg.getX());
            prefs.putInt("changeCaseY", changeCaseDlg.getY());
        }

        super.quit();
    }
}
