package net.sf.banglapad;

import com.apple.eawt.*;

import java.awt.Color;
import java.awt.Rectangle;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;

/**
 *  Mac OS X Functionality for VietPad
 *
 *@author     herr
 *@created    April 13, 2003
 */
class MacOSXApplication extends Application {

    private final static int ZOOM_LIMIT = 60;
            // http://www.mactech.com/articles/develop/issue_17/Yu_final.html


    /**
     *  Constructor for the MacOSXApplication object
     *
     *@param  vietPad  calling instance of VietPad
     */
    public MacOSXApplication(final BanglaPadWithTools vietPad) {

        vietPad.setMaximizedBounds(new Rectangle(
                Math.max(vietPad.getWidth(), vietPad.m_font.getSize() * ZOOM_LIMIT),
                Integer.MAX_VALUE));
        vietPad.scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        vietPad.scrollPane.setBorder(null); // line up scrollbars with grow box
        vietPad.m_toolBar.setBorder(BorderFactory.createCompoundBorder(
                BorderFactory.createMatteBorder(0, 0, 1, 0, new Color(0.5765F, 0.5765F, 0.5765F)), 
                vietPad.m_toolBar.getBorder()));

        setEnabledPreferencesMenu(true);

        addApplicationListener(new ApplicationAdapter() {
                public void handleAbout(ApplicationEvent e) {
                    e.setHandled(true);
                    vietPad.about();
                }


                public void handleOpenFile(ApplicationEvent e) {
                    File droppedFile = new File(e.getFilename());
                    if (droppedFile.isFile() && vietPad.promptToSave()) {
                        vietPad.openDocument(droppedFile);
                    }
                }


                public void handlePreferences(ApplicationEvent e) {
                    vietPad.preferences();
                }


                public void handlePrintFile(ApplicationEvent e) {
                    File droppedFile = new File(e.getFilename());
                    if (droppedFile.isFile() && vietPad.promptToSave()) {
                        vietPad.openDocument(droppedFile);
                        vietPad.printPage();
                    }
                }


                public void handleQuit(ApplicationEvent e) {
                    vietPad.quit();
                }
            });

    }
}
