package net.sf.banglapad;

/**
 * TestSpelling
 *
 *@author     Naushad UzZaman (naushadzaman@gmail.com)
 *@created    September 20, 2005
 *@version    0.1, December 10, 2005
 */

import java.io.File;
import java.awt.Font;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;

import javax.swing.JTextArea;
import javax.swing.JFrame;

import com.swabunga.spell.engine.SpellDictionary;
import com.swabunga.spell.engine.SpellDictionaryHashMap;
import com.swabunga.spell.swing.JTextComponentSpellChecker;

public class TestSpelling {
    protected JTextArea m_editor;
    protected JFrame jF;
    protected final File supportDir = new File(System.getProperty("user.home"));
    
    TestSpelling(){
    }
    
    public void createTextArea(){
        m_editor = new JTextArea();
        try{
            m_editor.setFont(new Font("Mukti Narrow", 1, 15));
        }catch(Exception e){
            System.out.println("can not find the font");
        }
        /**
         * FIXME: Changed the text. Previously we used to write Bangla in the 
         * java file using unicode, now we can write in Bangla as editor 
         */
        String textForJText = "কারাপ কসট ";//"mac";//
        m_editor.setText(textForJText);
        jF = new JFrame();
        jF.setSize(400, 300);
        System.out.println("naushad");
        jF.add(m_editor);
        jF.show();
    }
    
    public void spellCheck(){
        try {
            File customDictFile = new File(supportDir, "custom.dic");
            if (!customDictFile.exists()) {
                customDictFile.createNewFile();
            }
            String phonetFile = "dict/phonet.bn";//"dict/phonet.vi";//
            String dictFile = "dict/bn_BD.dic";//"dict/vi_VN.dic";//
            final Reader phonetReader = new InputStreamReader(ClassLoader.getSystemResourceAsStream(phonetFile), "UTF-8");
            final Reader mainDictReader = new InputStreamReader(ClassLoader.getSystemResourceAsStream(dictFile), "UTF-8");
            final SpellDictionary dictionary = new SpellDictionaryHashMap(mainDictReader, phonetReader);
            final SpellDictionary customDictionary = new SpellDictionaryHashMap(customDictFile, phonetReader);                        
     

            new Thread() {
                public void run() {
                    try {
                        JTextComponentSpellChecker sc = new JTextComponentSpellChecker(dictionary, customDictionary, "Spell_Check");
                        sc.spellCheck(m_editor);
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
            }.start();

            phonetReader.close();
            mainDictReader.close();
        } catch (Exception ex) {
            ex.printStackTrace();
    }       
    }

    public static void main(String[] args) throws IOException {
        TestSpelling ts = new TestSpelling();
        ts.createTextArea();
        ts.spellCheck();
    }
}
