package net.sf.banglapad;

/**
 * Unzip.java
 *
 *@author     Zahurul Islam (zahurul@bracuniversity.net)
 *@created    September 20, 2005
 *@version    0.1, December 10, 2005
 */

import java.io.*;
import java.util.zip.*;

public class UnZip {
    final static int BUFFER = 2048;
    
    
    public static String unzip(String fName, String outPath) {
        String diName = null;
        String separator = null;
        String fiName = null;
        String tmpDir = null;
        try {
            BufferedOutputStream dest = null;
            if (outPath == null) {
                tmpDir = System.getProperty("java.io.tmpdir") + File.separator; 
            } else {
                tmpDir = outPath;
            }
            
            FileInputStream fis = new 
            FileInputStream(fName);
            ZipInputStream zis = new 
            ZipInputStream(new BufferedInputStream(fis));
            ZipEntry entry;
            while((entry = zis.getNextEntry()) != null) {
                int count;
                byte data[] = new byte[BUFFER];
                // write the files to the disk
                String fileName = entry.getName();
                int ind1 = fileName.indexOf("/");
                if (ind1 != -1) {
                    separator = "/";
                } else {
                    separator = "\\";
                }
                
                ind1 = fileName.indexOf(separator);
                fiName = fileName.substring(0,fileName.indexOf(separator))+ File.separator;
                int ind2 = fileName.lastIndexOf(separator);
                if (ind2 != -1 && ind1!=-1 && ind1 != ind2) {
                    fiName = fiName + fileName.substring(fileName.indexOf(separator)+1,fileName.lastIndexOf(separator)) + File.separator;
                    fiName = fiName+ fileName.substring(fileName.lastIndexOf(separator)+1);
                } else {
                    fiName = fiName + fileName.substring(fileName.lastIndexOf(separator)+1);
                }
                
                diName = fileName.substring(0,fileName.indexOf(separator));
                
                int index = fileName.indexOf(separator);
                String dirName = null;
                String subDir = null;
                while (index > 1) {
                    if (subDir != null) 
                        dirName = subDir + fileName.substring(0,index);
                    else
                        dirName = fileName.substring(0,index);
                    String dName = tmpDir + dirName; 
                    File ff = new File(dName);
                    ff.mkdir();
                    
                    subDir = dirName + File.separator;  
                    fileName = fileName.substring(index + 1);
                    index = fileName.indexOf(separator);
                    if (index == -1 && fileName.length() >0) {
                        FileOutputStream fos = new FileOutputStream(tmpDir + fiName);
                        dest = new BufferedOutputStream(fos, BUFFER);
                        while ((count = zis.read(data, 0, BUFFER)) != -1) {
                            dest.write(data, 0, count);
                        }
                        dest.flush();
                        dest.close();
                    }
                } 
            }
            zis.close();
        } catch(Exception e) {
            e.printStackTrace();
        }
        return diName;
    }
}
