package net.sf.banglapad;

/**
 * Zip.java
 *
 *@author     Naushad UzZaman (naushadzaman@gmail.com)
 *@created    September 20, 2005
 *@version    0.1, December 10, 2005
 *
 */

/*
 parameters for save
 1. folder name (under system tmp dir), this includes document.html and images
 folder with images
 2. file name (given by user)
 3. save location (where to save, given by user)
 
 return 
 1. .bng file with user given file name in the correct location
 */

import java.io.*;
import java.util.zip.*;

public class Zip {
    final int BUFFER = 2048;
    byte data[]  = new byte[BUFFER];
    private String tmpDir = null;
    
    public void addToZipArchive(File f, String dirFile, BufferedInputStream origin, ZipOutputStream out){
        try{
            BPadLogger.logger.debug("Adding file to archive: "+f.toString());
            FileInputStream fi = new FileInputStream(f);
            origin = new 
            BufferedInputStream(fi, BUFFER);
            ZipEntry entry = new ZipEntry(dirFile);
            out.putNextEntry(entry);
            int count;
            while((count = origin.read(data, 0, 
                    BUFFER)) != -1) {
                out.write(data, 0, count);
            }
            origin.close();
        } catch(Exception e) {
            BPadLogger.logger.debug("Exception in adding a file for zip");
            e.printStackTrace();
        }
    }
    
    public void addToZip(String parentDir, String children, BufferedInputStream origin, ZipOutputStream out) {
        BPadLogger.logger.debug("Adding file to zip, from addToZip(), Zip: parent directory: "+parentDir+" fileName:"+children);
        File f = new File(parentDir, children);
        String files[] = f.list();
        int i = 0;
        while(i<files.length) {
            String dirFile = children + File.separator + files[i];
            File f2 = new File(parentDir, dirFile);
            if (!(f2.isDirectory())) {
                //add to Zip
                //adding to zip
                addToZipArchive(f2, dirFile, origin, out);
            }
            else {
                addToZip(parentDir, dirFile, origin, out);
            }
            i++;
        }
        
    }
    
    public void zipFiles(String parentDir, String dirName, String saveLocation, String fileName) {
        try {
        	BPadLogger.logger.debug("Received to zip with System tmp dir:"+parentDir+";timeStamp:"+dirName+";user save dir:"+saveLocation+";user file name"+fileName);
            BufferedInputStream origin  = null;
            FileOutputStream dest = new 
            FileOutputStream(saveLocation + File.separator + fileName);
            CheckedOutputStream checksum = new 
            CheckedOutputStream(dest, new Adler32());
            ZipOutputStream out = new 
            ZipOutputStream(new 
                    BufferedOutputStream(checksum));
            BPadLogger.logger.debug("Adding file to zip, from zipFiles(), Zip: parent directory: "+parentDir+" fileName:"+dirName);
            addToZip(parentDir, dirName, origin, out);
            out.close();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }   
}
